Index: /branches/avi_play/src/lib/graphics/importer/movie_player.cc
===================================================================
--- /branches/avi_play/src/lib/graphics/importer/movie_player.cc	(revision 6584)
+++ /branches/avi_play/src/lib/graphics/importer/movie_player.cc	(revision 6585)
@@ -49,6 +49,6 @@
 MoviePlayer::~MoviePlayer()
 {
-  delete material;
-  delete model;
+  //delete material;
+  //delete model;
 
   if (glIsTexture(texture))
@@ -81,5 +81,5 @@
   loading = false;
 
-  material = new Material;
+  /*material = new Material;
   material->setDiffuseMap("maps/radialTransparency.png");
 
@@ -90,4 +90,5 @@
   (new Light())->setAbsCoor(5.0, 10.0, 40.0);
   (new Light())->setAbsCoor(-10, -20, -100);
+  */
 }
 
@@ -195,5 +196,5 @@
       // Free the packet that was allocated by av_read_frame
       av_free_packet(&packet);
-      
+
       // Did we get a video frame?
       if(frame_finished)
@@ -248,5 +249,5 @@
 void MoviePlayer::skipFrame(int frames)
 {
-  
+
   while(frames != 0)
   {
@@ -259,5 +260,5 @@
       avcodec_decode_video(codec_context, frame, &frame_finished,
                             packet.data, packet.size);
-        
+
       // Did we get a video frame?
       if(frame_finished)
@@ -269,5 +270,5 @@
     av_free_packet(&packet);
   }
-  
+
   this->getNextFrame();
 
@@ -307,5 +308,5 @@
       return false;
     }
-    
+
     // go from the keyframe to the exact position
     codec_context->hurry_up = 1;
@@ -327,8 +328,8 @@
     } while(1);
     codec_context->hurry_up = 0;
-  
+
     this->frame_number = frames;
   }
-  
+
   return true;
 }
@@ -343,7 +344,7 @@
     status = PLAY;
     timer = 0;
-  
+
     this->gotoFrame(start_frame);
-  
+
     PRINTF(0)("start\n");
   }
@@ -387,10 +388,10 @@
       else
         this->skipFrame(actual_frame - frame_number - 1);
-    }   
+    }
     //PRINTF(0)("frame_number: %i\n", frame_number);
   }
 }
 
-const void MoviePlayer::draw()
+/*const void MoviePlayer::draw()
 {
   material->select();
@@ -399,4 +400,9 @@
 
   LightManager::getInstance()->draw();
+}*/
+
+GLuint MoviePlayer::getTexture()
+{
+  return this->texture;
 }
 
Index: /branches/avi_play/src/lib/graphics/importer/movie_player.h
===================================================================
--- /branches/avi_play/src/lib/graphics/importer/movie_player.h	(revision 6584)
+++ /branches/avi_play/src/lib/graphics/importer/movie_player.h	(revision 6585)
@@ -18,8 +18,8 @@
 #include "glincl.h"
 
-#include "light.h"
+//#include "light.h"
 #include "texture.h"
-#include "material.h"
-#include "primitive_model.h"
+//#include "material.h"
+//#include "primitive_model.h"
 
 // include base_object.h since all classes are derived from this one
@@ -29,6 +29,6 @@
 typedef enum MP_STATUS {
   PLAY,
-	PAUSE,
-	STOP
+        PAUSE,
+        STOP
 };
 
@@ -38,6 +38,6 @@
 private:
 
-  Model* model;
-  Material* material;
+  //Model* model;
+  //Material* material;
 
   AVFormatContext* format_context;
@@ -54,5 +54,5 @@
   int video_stream;
 
-  MP_STATUS status;	
+  MP_STATUS status;
   float timer;
   int start_frame;
@@ -61,5 +61,5 @@
   float fps;
   int duration;
-  bool loading;  
+  bool loading;
 
 public:
@@ -71,19 +71,20 @@
   bool loadMovie(const char* filename);
 
-	void start(float start_time);
-	void resume();
-	void pause();
-	void stop();
+        void start(float start_time);
+        void resume();
+        void pause();
+        void stop();
 
-	void tick(float dt);
-	const void draw();
+        void tick(float dt);
+        //const void draw();
+        GLuint getTexture();
 
-	void setFPS(float fps);
-	float getFPS();
-	const MP_STATUS getStatus();
+        void setFPS(float fps);
+        float getFPS();
+        const MP_STATUS getStatus();
   void printInformation();
 
 private:
-  
+
   void init();
   void getNextFrame();
Index: /branches/avi_play/src/story_entities/movie_loader.cc
===================================================================
--- /branches/avi_play/src/story_entities/movie_loader.cc	(revision 6584)
+++ /branches/avi_play/src/story_entities/movie_loader.cc	(revision 6585)
@@ -75,5 +75,5 @@
   this->isRunning = true;
 
-  this->run();
+  //this->run();
 }
 