Index: branches/height_map_merge/src/lib/graphics/importer/height_map.cc
===================================================================
--- branches/height_map_merge/src/lib/graphics/importer/height_map.cc	(revision 6579)
+++ branches/height_map_merge/src/lib/graphics/importer/height_map.cc	(revision 6603)
@@ -54,5 +54,19 @@
 void Tile::draw()
 {
- lowResModel->draw(); 
+	 // This Draws the LOD's
+	 							//FIXME
+    float cameraDistance = (State::getCamera()->getAbsCoor() - Vector(0.0,100.0,0.0)).len();
+    if (cameraDistance > 5000 )
+    {
+    
+    }
+    else if (cameraDistance > 1000 )
+    {
+      this->drawLowRes();
+    }
+    else 
+    {
+      this->drawHighRes();
+    }
 }
 
@@ -432,58 +446,14 @@
 int j_max= (heightMap->w - tileSize) / tileSize;
 
-// calc i_min , i_max j_min and j_maxt 
-
-int centerX =  (int)((heightMap->h - ((v.x - shiftX)/ (float)scaleX ))/ tileSize);
-int  centerY = (int)((v.z - shiftZ)/ (float)scaleZ )/ tileSize;
-//PRINTF(0)("i_max %i \n" , i_max);
-//PRINTF(0)("CENTERY %i \n ",centerY );
-i_min = max(centerX  -1, i_min);
-i_max = min(centerX +2 , i_max );
-
-j_min = max(centerY -1,1);
-j_max = min(centerY +2, j_max);
-
-
-for(int i = 1; i <  i_min	 ; i ++)
+
+
+for(int i = 1; i <  i_max	 ; i ++)
 {
 	for(int j = 1; j < j_max ; j++)
 	{
 	 	
-	 tiles[i][j]->drawLowRes();
+	 tiles[i][j]->draw();
 	}	
 } 
-for(int i = i_min; i <  i_max	 ; i ++)
-{
-	for(int j = j_min; j < j_max ; j++)
-	{
-	 	
-	 tiles[i][j]->drawHighRes();
-	}	
-}
-
-for(int i = i_max; i <  (heightMap->h -tileSize)/tileSize	 ; i ++)
-{
-	for(int j = 1; j < j_max ; j++)
-	{
-	 	
-	 tiles[i][j]->drawLowRes();
-	}	
-}
-
-
-for(int i = 1; i < (heightMap->h -tileSize)/tileSize; i++ )
-{
-	for(int j = 1; j < j_min; j++)
-	{
-	 tiles[i][j]->drawLowRes();
-	}
-}
-for(int i = 1; i < (heightMap->h -tileSize)/tileSize; i++) 
-{
-	for(int j = j_max; j < (heightMap->w -tileSize)/tileSize; j++ )
-	{
-	tiles[i][j]->drawLowRes();
-	}
-}
 
 }
Index: branches/height_map_merge/src/lib/graphics/importer/height_map.h
===================================================================
--- branches/height_map_merge/src/lib/graphics/importer/height_map.h	(revision 6579)
+++ branches/height_map_merge/src/lib/graphics/importer/height_map.h	(revision 6603)
@@ -17,7 +17,7 @@
 
 
-#define texRate      22
+#define texRate      64
 #define texRatef     4.0f
-#define tileSize     32
+#define tileSize     64
 
 class SDL_Surface;
Index: branches/height_map_merge/src/lib/graphics/importer/texture.cc
===================================================================
--- branches/height_map_merge/src/lib/graphics/importer/texture.cc	(revision 6579)
+++ branches/height_map_merge/src/lib/graphics/importer/texture.cc	(revision 6603)
@@ -264,6 +264,6 @@
 
 
-  glTexParameteri(target, GL_TEXTURE_WRAP_S, GL_REPEAT);
-  glTexParameteri(target, GL_TEXTURE_WRAP_T, GL_REPEAT);
+  // glTexParameteri(target, GL_TEXTURE_WRAP_S, GL_REPEAT);
+  // glTexParameteri(target, GL_TEXTURE_WRAP_T, GL_REPEAT);
 
   /* control the mipmap levels */
Index: branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc
===================================================================
--- branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc	(revision 6579)
+++ branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc	(revision 6603)
@@ -135,7 +135,14 @@
 void VertexArrayModel::draw() const
 {
+
+  glPushAttrib(GL_ALL_ATTRIB_BITS);
+  glColorMaterial ( GL_FRONT_AND_BACK, GL_EMISSION ) ;
+  glEnable (GL_COLOR_MATERIAL) ;
+
+
   PRINTF(4)("drawing 3D-VertexArrayModel %s\n", this->getName());
+ 
   glEnableClientState(GL_VERTEX_ARRAY );
-  //glEnableClientState(GL_TEXTURE_COORD_ARRAY );
+  glEnableClientState(GL_TEXTURE_COORD_ARRAY );
   glEnableClientState(GL_NORMAL_ARRAY );
   glEnableClientState(GL_COLOR_ARRAY );
@@ -144,6 +151,9 @@
   glVertexPointer(3, GL_FLOAT, 0, &this->vertices[0]);
   glNormalPointer(GL_FLOAT, 0, &this->normals[0]);
-  //glTexCoordPointer(2, GL_FLOAT, 0, &this->texCoords[0]);
+  glTexCoordPointer(2, GL_FLOAT, 0, &this->texCoords[0]);
   glColorPointer(3, GL_FLOAT, 0, &this->colors[0]);
+
+ 
+
 
   for (GLuint i = 1; i < this->stripes.size(); ++i)
@@ -154,4 +164,6 @@
                       &this->indices[this->stripes[i-1]] );
     }
+
+	glPopAttrib();
 }
 